"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const initArtemis_1 = __importDefault(require("./initArtemis"));
const head_1 = __importDefault(require("next/head"));
const react_apollo_1 = require("react-apollo");
const react_1 = __importDefault(require("react"));
const isBrowser = typeof window !== undefined;
exports.default = (App) => {
    var _a;
    return _a = class Artemis extends react_1.default.Component {
            constructor(props) {
                super(props);
                this.artemisClient = props.artemisClient || initArtemis_1.default(props.artemisState.data);
            }
            static async getInitialProps(ctx) {
                const { Component, router } = ctx;
                let appProps = {};
                if (App.getInitialProps) {
                    appProps = await App.getInitialProps(ctx);
                }
                const artemisState = {};
                const artemis = initArtemis_1.default();
                try {
                    await react_apollo_1.getDataFromTree(react_1.default.createElement(App, Object.assign({}, appProps, { Component: Component, router: router, apolloState: artemisState, apolloClient: artemis })));
                }
                catch (error) {
                    console.error("Error while running `getDataFromTree`", error);
                }
                if (!isBrowser) {
                    // getDataFromTree does not call componentWillUnmount
                    // we need to clear the <Head> manually
                    head_1.default.rewind();
                }
                artemisState.data = artemis.cache.extract();
                return Object.assign({}, appProps, { artemisState });
            }
            render() {
                return react_1.default.createElement(App, Object.assign({}, this.props, { artemisClient: this.artemisClient }));
            }
        },
        _a.displayName = "withArtemis(App)",
        _a;
};
